--
-- smokingFarmer
--
-- @author:    	Xentro (Marcus@Xentro.se)
-- @website:	www.Xentro.se
-- @history:	v1.0 - 2012-11-03 - Initial implementation
-- 				v1.1 - 2016-12-06 - FS17 Convert
--
-- <smokingFarmer pipeNode="0>6|4" node="0>6|7" position="0 0 0" rotation="0 0 0" file="$data/particleSystems/shared/threshingStrawParticles.i3d" />

smokingFarmer = {};

function smokingFarmer.prerequisitesPresent(specializations)
    return true;
end;

function smokingFarmer:load(saveGame)
	self.pipeNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.smokingFarmer#pipeNode"));
	
	smokingFarmer.setFarmerStuff(self, false); -- set pipe to false
	
	self.smokingFarmerParticleSystems = {};
	ParticleUtil.loadParticleSystem(self.xmlFile, self.smokingFarmerParticleSystems, "vehicle.smokingFarmer", self.components, false, nil, self.baseDirectory);
end;

function smokingFarmer:delete()
	ParticleUtil.deleteParticleSystem(self.smokingFarmerParticleSystems);
end;

function smokingFarmer:readStream(streamId, connection)
end;

function smokingFarmer:writeStream(streamId, connection)
end;

function smokingFarmer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function smokingFarmer:keyEvent(unicode, sym, modifier, isDown)
end;

function smokingFarmer:update(dt)
end;

function smokingFarmer:updateTick(dt)
end;

function smokingFarmer:draw()
end;

function smokingFarmer:onCameraChanged(camera, cameraIndex)
	if self.isClient and self.pipeNode ~= nil then
		setVisibility(self.pipeNode, not camera.isInside);
	end;
end;

function smokingFarmer:onEnter()
	smokingFarmer.setFarmerStuff(self, true);
end;

function smokingFarmer:onLeave()
	smokingFarmer.setFarmerStuff(self, false);
end;

function smokingFarmer:setFarmerStuff(state)
	if self.pipeNode ~= nil then
		setVisibility(self.pipeNode, state);
	end;
	
	ParticleUtil.setEmittingState(self.smokingFarmerParticleSystems, state);
end;